<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.5"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>DayZExpansion: DayzExpansion/BaseBuilding/Scripts/5_mission/dayzexpansion_basebuilding/classes/modules/esp/basebuilding/jmespmetabasebuilding.c Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="../../doxygen_light.png"/></td>
  <td id="projectalign">
   <div id="projectname">DayZExpansion<span id="projectnumber">&#160;1.7.12</span>
   </div>
   <div id="projectbrief">DayZExpansion Script Documentation Courtecy of P4K1TZ</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.5 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "../../search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('../../',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(document).ready(function(){initNavTree('d9/d34/a00476_source.html','../../'); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="headertitle"><div class="title">jmespmetabasebuilding.c</div></div>
</div><!--header-->
<div class="contents">
<a href="../../d9/d34/a00476.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/**</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * JMESPMetaBaseBuilding.c</span></div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> *</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> * DayZ Expansion Mod</span></div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment"> * www.dayzexpansion.com</span></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment"> * © 2022 DayZ Expansion Mod Team</span></div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span><span class="comment"> *</span></div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span><span class="comment"> * This work is licensed under the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International License. </span></div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span><span class="comment"> * To view a copy of this license, visit http://creativecommons.org/licenses/by-nc-nd/4.0/.</span></div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span><span class="comment"> *</span></div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span><span class="comment">*/</span></div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span> </div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span><span class="preprocessor">#ifdef JM_COT</span></div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span>modded <span class="keyword">class </span>JMESPMetaBaseBuilding</div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span>{</div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span>    ExpansionESPModificationModule exp_Module;</div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span> </div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span>    UIActionText m_Action_Code;</div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span> </div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span>    UIActionButton m_Action_RequestCode;</div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span>    UIActionButton m_Action_RemoveCode;</div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span> </div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../dd/dd8/a00719.html#a4b44a5fd9d194672f82f559e4536801b">Create</a>( JMESPModule mod )</div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span>    {</div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span>        CF_Modules&lt;ExpansionESPModificationModule&gt;.Get(exp_Module);</div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span> </div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span>        super.Create( mod );</div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span>    }</div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span>    </div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span> </div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span>    <span class="keyword">override</span> <span class="keywordtype">void</span> CreateActions( Widget parent )</div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span>    {</div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span>        super.CreateActions( parent );</div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span> </div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span>        <span class="keywordflow">if</span> ( HasCodeLock() )</div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span>        {</div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span>            UIActionManager.CreatePanel( parent, 0xFF000000, 1 );</div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span> </div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span>            m_Action_Code = UIActionManager.CreateText( parent, <span class="stringliteral">&quot;Codelock: &quot;</span>, <span class="stringliteral">&quot;UNKNOWN CODE&quot;</span> );</div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span>            m_Action_RequestCode = UIActionManager.CreateButton( parent, <span class="stringliteral">&quot;Refresh Code&quot;</span>, <span class="keyword">this</span>, <span class="stringliteral">&quot;Action_RequestCode&quot;</span> );</div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span>            m_Action_RemoveCode = UIActionManager.CreateButton( parent, <span class="stringliteral">&quot;Remove Code&quot;</span>, <span class="keyword">this</span>, <span class="stringliteral">&quot;Action_RemoveCode&quot;</span> );</div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span>        }</div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span> </div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno">   44</span>        UpdateButtonStates();</div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno">   45</span>    }</div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span> </div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span>    <span class="keywordtype">bool</span> HasCodeLock()</div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno">   48</span>    {</div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno">   49</span>        <a class="code hl_class" href="../../d4/d93/a03781.html">ExpansionWallBase</a> expwall;</div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span>        <a class="code hl_class" href="../../d2/d11/a03797.html">Fence</a> fence;</div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span>        <span class="keywordflow">if</span> ( Class.CastTo( expwall, target ) )</div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span>        {</div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span>            <span class="keywordflow">return</span> ( expwall.<a class="code hl_function" href="../../d4/d93/a03781.html#a15b80f2912c6c9354bb5818bd3285066">ExpansionHasCodeLock</a>( <span class="stringliteral">&quot;codelock_door&quot;</span> ) || expwall.<a class="code hl_function" href="../../d4/d93/a03781.html#a15b80f2912c6c9354bb5818bd3285066">ExpansionHasCodeLock</a>( <span class="stringliteral">&quot;codelock_gate&quot;</span> ) );</div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span>        }</div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span>        <span class="keywordflow">else</span> <span class="keywordflow">if</span> ( Class.CastTo( fence, target ) )</div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span>        {</div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span>            <span class="keywordflow">if</span> ( fence.<a class="code hl_function" href="../../d2/d11/a03797.html#a03408a398b262efa1302eff8b14efa56">ExpansionCanAttachCodeLock</a>() )</div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span>            {</div>
<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span>                <span class="keywordflow">return</span> fence.ExpansionHasCodeLock( <span class="stringliteral">&quot;codelock&quot;</span> );</div>
<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span>            }</div>
<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span>        }</div>
<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span> </div>
<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span>        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>    }</div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span> </div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>    <span class="keyword">override</span> <span class="keyword">private</span> <span class="keywordtype">void</span> UpdateButtonStates()</div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>    {</div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span>        super.UpdateButtonStates();</div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span> </div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span>        <span class="keywordflow">for</span> ( <span class="keywordtype">int</span> i = 0; i &lt; m_StateHeaders.Count(); ++i )</div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span>        {</div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span>            JMConstructionPartData data;</div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span>            Class.CastTo( data, m_StateHeaders[i].GetData() );</div>
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span> </div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span>            <span class="keywordflow">if</span> ( data.m_State == JMConstructionPartState.CONFLICTING_PART )</div>
<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span>            {</div>
<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span>                m_StateHeaders[i].Hide();</div>
<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span>                m_BuildButtons[i].Hide();</div>
<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span>                m_DismantleButtons[i].Hide();</div>
<div class="line"><a id="l00080" name="l00080"></a><span class="lineno">   80</span>                m_RepairButtons[i].Hide();</div>
<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span>            } <span class="keywordflow">else</span> <span class="keywordflow">if</span> ( data.m_State == JMConstructionPartState.REQUIRED_PART_NOT_BUILT )</div>
<div class="line"><a id="l00082" name="l00082"></a><span class="lineno">   82</span>            {</div>
<div class="line"><a id="l00083" name="l00083"></a><span class="lineno">   83</span>                m_StateHeaders[i].Hide();</div>
<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span>                m_BuildButtons[i].Hide();</div>
<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span>                m_DismantleButtons[i].Hide();</div>
<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span>                m_RepairButtons[i].Hide();</div>
<div class="line"><a id="l00087" name="l00087"></a><span class="lineno">   87</span>            } <span class="keywordflow">else</span> {</div>
<div class="line"><a id="l00088" name="l00088"></a><span class="lineno">   88</span>                m_StateHeaders[i].Show();</div>
<div class="line"><a id="l00089" name="l00089"></a><span class="lineno">   89</span>            }</div>
<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span>        }</div>
<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span>    }</div>
<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span> </div>
<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span>    <span class="keywordtype">void</span> SetCode( <span class="keywordtype">string</span> code )</div>
<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span>    {</div>
<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span>        m_Action_Code.SetText( code );</div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span>    }</div>
<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span> </div>
<div class="line"><a id="l00098" name="l00098"></a><span class="lineno">   98</span>    <span class="keywordtype">void</span> Action_RequestCode( UIEvent eid, UIActionBase action )</div>
<div class="line"><a id="l00099" name="l00099"></a><span class="lineno">   99</span>    {</div>
<div class="line"><a id="l00100" name="l00100"></a><span class="lineno">  100</span>        <span class="keywordflow">if</span> ( eid != UIEvent.CLICK )</div>
<div class="line"><a id="l00101" name="l00101"></a><span class="lineno">  101</span>            <span class="keywordflow">return</span>;</div>
<div class="line"><a id="l00102" name="l00102"></a><span class="lineno">  102</span> </div>
<div class="line"><a id="l00103" name="l00103"></a><span class="lineno">  103</span>        exp_Module.RequestCode( target );</div>
<div class="line"><a id="l00104" name="l00104"></a><span class="lineno">  104</span>    }</div>
<div class="line"><a id="l00105" name="l00105"></a><span class="lineno">  105</span> </div>
<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span>    <span class="keywordtype">void</span> Action_RemoveCode( UIEvent eid, UIActionBase action )</div>
<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span>    {</div>
<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>        <span class="keywordflow">if</span> ( eid != UIEvent.CLICK )</div>
<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span>            <span class="keywordflow">return</span>;</div>
<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span> </div>
<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span>        exp_Module.RemoveCode( target );</div>
<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span>    }</div>
<div class="line"><a id="l00113" name="l00113"></a><span class="lineno">  113</span>};</div>
<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span><span class="preprocessor">#endif</span></div>
<div class="ttc" id="aa00719_html_a4b44a5fd9d194672f82f559e4536801b"><div class="ttname"><a href="../../dd/dd8/a00719.html#a4b44a5fd9d194672f82f559e4536801b">Create</a></div><div class="ttdeci">void Create(PlayerIdentity identity=NULL)</div><div class="ttdef"><b>Definition:</b> <a href="../../dd/dd8/a00719_source.html#l00150">expansionnotificationsystem.c:150</a></div></div>
<div class="ttc" id="aa03781_html"><div class="ttname"><a href="../../d4/d93/a03781.html">ExpansionWallBase</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d91/a00410_source.html#l00013">expansionwall.c:14</a></div></div>
<div class="ttc" id="aa03781_html_a15b80f2912c6c9354bb5818bd3285066"><div class="ttname"><a href="../../d4/d93/a03781.html#a15b80f2912c6c9354bb5818bd3285066">ExpansionWallBase::ExpansionHasCodeLock</a></div><div class="ttdeci">override bool ExpansionHasCodeLock(string selection)</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d91/a00410_source.html#l00226">expansionwall.c:226</a></div></div>
<div class="ttc" id="aa03797_html"><div class="ttname"><a href="../../d2/d11/a03797.html">Fence</a></div><div class="ttdef"><b>Definition:</b> <a href="../../dc/d2f/a00425_source.html#l00015">fence.c:16</a></div></div>
<div class="ttc" id="aa03797_html_a03408a398b262efa1302eff8b14efa56"><div class="ttname"><a href="../../d2/d11/a03797.html#a03408a398b262efa1302eff8b14efa56">Fence::ExpansionCanAttachCodeLock</a></div><div class="ttdeci">bool ExpansionCanAttachCodeLock()</div><div class="ttdoc">Only call this after settings have been loaded.</div><div class="ttdef"><b>Definition:</b> <a href="../../dc/d2f/a00425_source.html#l00045">fence.c:45</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_6127fff2da0a20e2dc2cd9302c584350.html">DayzExpansion</a></li><li class="navelem"><a class="el" href="../../dir_e66306a3976d6d81f5e1305840c1314d.html">BaseBuilding</a></li><li class="navelem"><a class="el" href="../../dir_92106a510097343a3fe1c14124c59151.html">Scripts</a></li><li class="navelem"><a class="el" href="../../dir_de119202d4d7d77060c2650b6b182e1f.html">5_mission</a></li><li class="navelem"><a class="el" href="../../dir_cac75cb36f33f2619f18c276b03975f2.html">dayzexpansion_basebuilding</a></li><li class="navelem"><a class="el" href="../../dir_735fd25a60c705052c2ab1c859cb0855.html">classes</a></li><li class="navelem"><a class="el" href="../../dir_48e831273f587587fa2ae061da8300ed.html">modules</a></li><li class="navelem"><a class="el" href="../../dir_0f42f8e8319488862442948f39eb250e.html">esp</a></li><li class="navelem"><a class="el" href="../../dir_2cb05e1b620392218d4e965a398882f4.html">basebuilding</a></li><li class="navelem"><a class="el" href="../../d9/d34/a00476.html">jmespmetabasebuilding.c</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.5 </li>
  </ul>
</div>
</body>
</html>
